'' turn hypertrm into a video player! sort of.

'' the settings will only really work with bright objects and dark background or viceversa -- i tested this with the symbol '+ in duct tape on a white wall -- it works.

con

   _clkmode  = xtal1 | pll16x 
   _xinfreq  = 5_000_000


obj

debug: "FullDuplexSerial"
cam:"propcamera_module"




pub start | ch, pixel, pxcnt,                             pixel2,                           trakp, trakm

ch~
dira~ ' all inputs for this guy

debug.start(31,30,%0000,115200)


cam.start

trakme := 127
dodisplay := 1

repeat 2000
    debug.tx(ch++)

waitcnt(cnt+(_xinfreq*10))
    
repeat
  'cam.runonce(false)
  lmax~
  lmin := $FF
  lmed~
  pxcnt~
  ch~

'' figure out min, max and average values for scene light
  
  repeat cam#ARRAYSIZE
    pixel := byte[cam.pxladdr(ch++,false)]
    
    if (pixel < $FD) and (pixel > $10) ' limits defined by the module so we can have flag values
    
      if pixel > lmax
        lmax := pixel
      if pixel < lmin
        lmin := pixel
      lmed += pixel
      pxcnt++

  ldiff := lmax-lmin
  lmed := lmed / pxcnt '(lmax+lmin)/2

                              

'' generate tressholds

  ldiff := ldiff / 5 
  ' zero
  TREVAL1 := lmin + (ldiff * 1)
  TREVAL2 := lmin + (ldiff * 2)
  TREVAL3 := lmin + (ldiff * 3)
  TREVAL4 := lmin + (ldiff * 4)
  ' max
   
'' print ascii-art scene to terminal
  ch~
  trakm := trakme - trakwin
  trakp := trakme + trakwin
  
  if dodisplay
   repeat cam#ARRAYSIZE
    pixel := byte[cam.pxladdr(ch,false)]
    if pixel == $FE
                debug.tx("!")
    elseif pixel == $FF
                debug.tx(13)
                debug.tx(10)
    else
           case  pixel
                  trakm..trakp:debug.tx(traklevel)
                  lmax: debug.tx(trakmax)
                  lmin: debug.tx(trakmin)
                  $00..TREVAL1: debug.tx(greylevels[4])
                  TREVAL1..TREVAL2: debug.tx(greylevels[3])                                        
                  TREVAL2..TREVAL3: debug.tx(greylevels[2])
                  TREVAL3..TREVAL4: debug.tx(greylevels[1])
                  other: debug.tx(greylevels[0])       
    ch++
  if autoload
      longmove(@page, cam.frm, cam#ARRAYSIZE/4)  
    
'' go back and do it again
  debug.tx(13)
  debug.tx(lastch)
  debug.tx(",")
  debug.dec(lmax)
  debug.tx(" ")
  debug.dec(lmed)
  debug.tx(" ")
  debug.dec(lmin)
  debug.tx(",")
  debug.dec(trakme)
  debug.tx("(")
  debug.dec(trakwin)
  debug.tx(")")
  ch := debug.rxcheck
  if ch > -1
     lastch := command := ch
  else
     command~   

  case command
     "i": invert    ' invert for black-on white vs white-on-black displays
     "[": trakme--    ' mark a pixel of this brightness with a special character
     "]": trakme++     ' mark a pixel of this brightness with a special character
     ".": trakwin--   ' inc/dec trakme window
     ",": trakwin++   ' inc/dec trakme window
     "m":        ' toggle tracking MAXIMUMS on/off
          command := trakmax
          trakmax := trakmax[1]
          trakmax[1] := command
     "n":      ' toggle tracking MINIMUMS on/off
          command := trakmin
          trakmin := trakmin[1]
          trakmin[1] := command
          
     "s": longmove(@page, cam.frm, cam#ARRAYSIZE/4) ' save: save a page. Also turns off autoload
          autoload~

     "l": ch~  ' load: print page. 


        repeat cam#ARRAYSIZE
          pixel := page[ch]
          if pixel == $FE
                debug.tx("!")
          elseif pixel == $FF
                debug.tx(13)
                debug.tx(10)
          else
           case  pixel
                  trakm..trakp:debug.tx(traklevel)
                  lmax: debug.tx(trakmax)
                  lmin: debug.tx(trakmin)
                  $00..TREVAL1: debug.tx(greylevels[4])
                  TREVAL1..TREVAL2: debug.tx(greylevels[3])                                        
                  TREVAL2..TREVAL3: debug.tx(greylevels[2])
                  TREVAL3..TREVAL4: debug.tx(greylevels[1])
                  other: debug.tx(greylevels[0])       
          ch++

     "d": ch~    ' differences what's being seen now with what's been saved


        repeat cam#ARRAYSIZE
          pixel := byte[cam.pxladdr(ch,false)]
          if pixel == $FE
                debug.tx("!")
          elseif pixel == $FF
                debug.tx(13)
                debug.tx(10)
          else
           pixel2 := page[ch]
           case  127 + (pixel/2) - (pixel2/2)
                  trakm..trakp:debug.tx(traklevel)
                  lmax: debug.tx(trakmax)
                  lmin: debug.tx(trakmin)
                  $00..TREVAL1: debug.tx(greylevels[4])
                  TREVAL1..TREVAL2: debug.tx(greylevels[3])                                        
                  TREVAL2..TREVAL3: debug.tx(greylevels[2])
                  TREVAL3..TREVAL4: debug.tx(greylevels[1])
                  other: debug.tx(greylevels[0])       
          ch++


     "x": dodisplay := not dodisplay ' display on/off
     
     "a": autoload := 1 ' save each frame (rolling diff)
     
     other: command~   
  command~

var
byte page[cam#ARRAYSIZE]
byte dodisplay
byte autoload

pub invert 

temp[0] := greylevels[0]
temp[1] := greylevels[1]
temp[2] := greylevels[2]
temp[3] := greylevels[3]
temp[4] := greylevels[4]   

 greylevels[0] := temp[4]
 greylevels[1] := temp[3]
 greylevels[2] := temp[2]
 greylevels[3] := temp[1]
 greylevels[4] := temp[0]

temp[5] := trakmax
trakmax := trakmin
trakmin := temp[5] 

temp[5] := trakmax[1]
trakmax[1] := trakmin[1]
trakmin[1] := temp[5] 
 

var
byte temp[6]
byte lastch, command
byte trakme
byte trakwin

con


GREY_LEVELS = 5

dat
'greylevels byte "#","%","+","`"," "
greylevels byte "","","",""," "   ' from darkest to lightest
traklevel  byte "@","@"
trakmax    byte "","+"
trakmin    byte " ","-"

var
long lmax, lmin, lmed, ldiff, TREVAL1, TREVAL2, TREVAL3, TREVAL4
           